Index: trunk/src/org/openstreetmap/josm/tools/ImageProvider.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 6809)
+++ trunk/src/org/openstreetmap/josm/tools/ImageProvider.java	(revision 6814)
@@ -22,5 +22,4 @@
 import java.io.StringReader;
 import java.io.UnsupportedEncodingException;
-import java.net.MalformedURLException;
 import java.net.URI;
 import java.net.URL;
@@ -360,5 +359,7 @@
 
     /**
-     * @see #get(java.lang.String, java.lang.String)
+     * @param name The icon name (base name with or without '.png' or '.svg' extension)
+     * @return the requested image or null if the request failed
+     * @see #get(String, String)
      */
     public static ImageIcon get(String name) {
@@ -369,5 +370,9 @@
      * Load an image with a given file name, but do not throw an exception
      * when the image cannot be found.
-     * @see #get(java.lang.String, java.lang.String)
+     *
+     * @param subdir subdirectory the image lies in
+     * @param name The icon name (base name with or without '.png' or '.svg' extension)
+     * @return the requested image or null if the request failed
+     * @see #get(String, String)
      */
     public static ImageIcon getIfAvailable(String subdir, String name) {
@@ -376,5 +381,7 @@
 
     /**
-     * @see #getIfAvailable(java.lang.String, java.lang.String)
+     * @param name The icon name (base name with or without '.png' or '.svg' extension)
+     * @return the requested image or null if the request failed
+     * @see #getIfAvailable(String, String)
      */
     public static ImageIcon getIfAvailable(String name) {
@@ -854,5 +861,5 @@
      * @param img the image to be rotated.
      * @param rotatedAngle the rotated angle, in degree, clockwise. It could be any double but we
-     * will mod it with 360 before using it. More over for caching performance, it will be rounded to 
+     * will mod it with 360 before using it. More over for caching performance, it will be rounded to
      * an entire value between 0 and 360.
      *
@@ -863,5 +870,5 @@
         return createRotatedImage(img, rotatedAngle, ImageResource.DEFAULT_DIMENSION);
     }
-    
+
     /**
      * Creates a rotated version of the input image, scaled to the given dimension.
@@ -869,5 +876,5 @@
      * @param img the image to be rotated.
      * @param rotatedAngle the rotated angle, in degree, clockwise. It could be any double but we
-     * will mod it with 360 before using it. More over for caching performance, it will be rounded to 
+     * will mod it with 360 before using it. More over for caching performance, it will be rounded to
      * an entire value between 0 and 360.
      * @param dimension The requested dimensions. Use (-1,-1) for the original size
@@ -878,5 +885,5 @@
     public static Image createRotatedImage(Image img, double rotatedAngle, Dimension dimension) {
         CheckParameterUtil.ensureParameterNotNull(img, "img");
-        
+
         // convert rotatedAngle to an integer value from 0 to 360
         Long originalAngle = Math.round(rotatedAngle % 360);
@@ -884,5 +891,5 @@
             originalAngle = 360L;
         }
-        
+
         ImageResource imageResource = null;
 
@@ -892,7 +899,7 @@
                 ROTATE_CACHE.put(img, cacheByAngle = new HashMap<Long, ImageResource>());
             }
-            
+
             imageResource = cacheByAngle.get(originalAngle);
-            
+
             if (imageResource == null) {
                 // convert originalAngle to a value from 0 to 90
@@ -901,7 +908,7 @@
                     angle = 90.0;
                 }
-        
+
                 double radian = Math.toRadians(angle);
-        
+
                 new ImageIcon(img); // load completely
                 int iw = img.getWidth(null);
@@ -909,5 +916,5 @@
                 int w;
                 int h;
-        
+
                 if ((originalAngle >= 0 && originalAngle <= 90) || (originalAngle > 180 && originalAngle <= 270)) {
                     w = (int) (iw * Math.sin(DEGREE_90 - radian) + ih * Math.sin(radian));
@@ -921,18 +928,18 @@
                 Graphics g = image.getGraphics();
                 Graphics2D g2d = (Graphics2D) g.create();
-        
+
                 // calculate the center of the icon.
                 int cx = iw / 2;
                 int cy = ih / 2;
-        
+
                 // move the graphics center point to the center of the icon.
                 g2d.translate(w / 2, h / 2);
-        
+
                 // rotate the graphics about the center point of the icon
                 g2d.rotate(Math.toRadians(originalAngle));
-        
+
                 g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
                 g2d.drawImage(img, -cx, -cy, null);
-        
+
                 g2d.dispose();
                 new ImageIcon(image); // load completely
@@ -941,10 +948,10 @@
         }
     }
-    
+
     /**
      * Creates a scaled down version of the input image to fit maximum dimensions. (Keeps aspect ratio)
      *
      * @param img the image to be scaled down.
-     * @param maxSize the maximum size in pixels (both for width and height) 
+     * @param maxSize the maximum size in pixels (both for width and height)
      *
      * @return the image after scaling.