Index: trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/AudioPlayer.java	(revision 6830)
@@ -19,5 +19,5 @@
  * Creates and controls a separate audio player thread.
  *
- * @author David Earl <david@frankieandshadow.com>
+ * @author David Earl &lt;david@frankieandshadow.com&gt;
  * @since 547
  */
@@ -124,5 +124,5 @@
      * @param url The resource to play, which must be a WAV file or stream
      * @param seconds The number of seconds into the audio to start playing
-     * @param speed Rate at which audio playes (1.0 = real time, > 1 is faster)
+     * @param speed Rate at which audio playes (1.0 = real time, &gt; 1 is faster)
      * @throws Exception audio fault exception, e.g. can't open stream,  unhandleable audio format
      */
Index: trunk/src/org/openstreetmap/josm/tools/AudioUtil.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/AudioUtil.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/AudioUtil.java	(revision 6830)
@@ -14,5 +14,5 @@
  * Utils functions for audio.
  *
- * @author David Earl <david@frankieandshadow.com>
+ * @author David Earl &lt;david@frankieandshadow.com&gt;
  * @since 1462
  */
@@ -22,5 +22,5 @@
         // Hide default constructor for utils classes
     }
-    
+
     /**
      * Returns calibrated length of recording in seconds.
Index: trunk/src/org/openstreetmap/josm/tools/ColorHelper.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ColorHelper.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/ColorHelper.java	(revision 6830)
@@ -5,5 +5,5 @@
 
 /**
- * Helper to convert from color to html string and back
+ * Helper to convert from color to HTML string and back.
  */
 public final class ColorHelper {
@@ -12,5 +12,5 @@
         // Hide default constructor for utils classes
     }
-    
+
     /**
      * Returns the {@code Color} for the given HTML code.
@@ -55,5 +55,5 @@
      * Returns the HTML color code (6 or 8 digit).
      * @param col The color to convert
-     * @param withAlpha if {@code true} and alpha value < 255, return 8-digit color code, else always 6-digit
+     * @param withAlpha if {@code true} and alpha value &lt; 255, return 8-digit color code, else always 6-digit
      * @return the HTML color code (6 or 8 digit)
      * @since 6655
Index: trunk/src/org/openstreetmap/josm/tools/Diff.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Diff.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/Diff.java	(revision 6830)
@@ -57,5 +57,5 @@
     and <code>hashcode</code> methods for the objects compared.
 <p>
-   The basic algorithm is described in: </br>
+   The basic algorithm is described in: <br>
    "An O(ND) Difference Algorithm and its Variations", Eugene Myers,
    Algorithmica Vol. 1 No. 2, 1986, p 251.
@@ -589,4 +589,5 @@
         }
 
+        @Override
         public String toString() {
             String s = String.format("%d -%d +%d %d",line0,deleted,inserted,line1);
@@ -830,5 +831,5 @@
             realindexes = new int[buffered_lines];
         }
-        
+
         FileData(Object[] data, Map<Object,Integer> h) {
             this(data.length);
Index: trunk/src/org/openstreetmap/josm/tools/ExceptionUtil.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ExceptionUtil.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/ExceptionUtil.java	(revision 6830)
@@ -38,5 +38,5 @@
 @SuppressWarnings("CallToThreadDumpStack")
 public final class ExceptionUtil {
-    
+
     private ExceptionUtil() {
         // Hide default constructor for utils classes
@@ -697,5 +697,5 @@
 
     /**
-     * Replaces some HTML reserved characters (<, > and &) by their equivalent entity (&lt;, &gt; and &amp;);
+     * Replaces some HTML reserved characters (&lt;, &gt; and &amp;) by their equivalent entity (&amp;lt;, &amp;gt; and &amp;amp;);
      * @param s The unescaped string
      * @return The escaped string
Index: trunk/src/org/openstreetmap/josm/tools/ExifReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/ExifReader.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/ExifReader.java	(revision 6830)
@@ -31,5 +31,5 @@
         // Hide default constructor for utils classes
     }
-    
+
     /**
      * Returns the date/time from the given JPEG file.
@@ -70,13 +70,13 @@
      * Returns the image orientation of the given JPEG file.
      * @param filename The JPEG file to read
-     * @return The image orientation as an {@code int}. Default value is 1. Possible values are listed in EXIF spec as follows:<br>
-     * <ul>1. The 0th row is at the visual top of the image, and the 0th column is the visual left-hand side.</ul>
-     * <ul>2. The 0th row is at the visual top of the image, and the 0th column is the visual right-hand side.</ul>
-     * <ul>3. The 0th row is at the visual bottom of the image, and the 0th column is the visual right-hand side.</ul>
-     * <ul>4. The 0th row is at the visual bottom of the image, and the 0th column is the visual left-hand side.</ul>
-     * <ul>5. The 0th row is the visual left-hand side of the image, and the 0th column is the visual top.</ul>
-     * <ul>6. The 0th row is the visual right-hand side of the image, and the 0th column is the visual top.</ul>
-     * <ul>7. The 0th row is the visual right-hand side of the image, and the 0th column is the visual bottom.</ul>
-     * <ul>8. The 0th row is the visual left-hand side of the image, and the 0th column is the visual bottom.</ul>
+     * @return The image orientation as an {@code int}. Default value is 1. Possible values are listed in EXIF spec as follows:<br><ol>
+     * <li>The 0th row is at the visual top of the image, and the 0th column is the visual left-hand side.</li>
+     * <li>The 0th row is at the visual top of the image, and the 0th column is the visual right-hand side.</li>
+     * <li>The 0th row is at the visual bottom of the image, and the 0th column is the visual right-hand side.</li>
+     * <li>The 0th row is at the visual bottom of the image, and the 0th column is the visual left-hand side.</li>
+     * <li>The 0th row is the visual left-hand side of the image, and the 0th column is the visual top.</li>
+     * <li>The 0th row is the visual right-hand side of the image, and the 0th column is the visual top.</li>
+     * <li>The 0th row is the visual right-hand side of the image, and the 0th column is the visual bottom.</li>
+     * <li>The 0th row is the visual left-hand side of the image, and the 0th column is the visual bottom.</li></ol>
      * @see <a href="http://www.impulseadventure.com/photo/exif-orientation.html">http://www.impulseadventure.com/photo/exif-orientation.html</a>
      * @see <a href="http://www.daveperrett.com/articles/2012/07/28/exif-orientation-handling-is-a-ghetto">http://www.daveperrett.com/articles/2012/07/28/exif-orientation-handling-is-a-ghetto</a>
@@ -133,5 +133,5 @@
         return null;
     }
-    
+
     /**
      * Returns the direction of the given JPEG file.
@@ -152,5 +152,5 @@
         return null;
     }
-    
+
     /**
      * Returns the direction of the given EXIF GPS directory.
@@ -176,10 +176,10 @@
             double min = components[1].doubleValue();
             double sec = components[2].doubleValue();
-   
+
             if (Double.isNaN(deg) && Double.isNaN(min) && Double.isNaN(sec))
                 throw new IllegalArgumentException();
-   
+
             value = (Double.isNaN(deg) ? 0 : deg + (Double.isNaN(min) ? 0 : (min / 60)) + (Double.isNaN(sec) ? 0 : (sec / 3600)));
-   
+
             if (dirGps.getString(gpsTagRef).charAt(0) == cRef) {
                 value = -value;
Index: trunk/src/org/openstreetmap/josm/tools/Geometry.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Geometry.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/Geometry.java	(revision 6830)
@@ -37,9 +37,9 @@
  */
 public final class Geometry {
-    
+
     private Geometry() {
         // Hide default constructor for utils classes
     }
-    
+
     public enum PolygonIntersection {FIRST_INSIDE_SECOND, SECOND_INSIDE_FIRST, OUTSIDE, CROSSING}
 
@@ -771,5 +771,5 @@
      * Tests if the polygon formed by {@code nodes} is inside the multipolygon {@code multiPolygon}. The nullable argument
      * {@code isOuterWayAMatch} allows to decide if the immediate {@code outer} way of the multipolygon is a match.
-     * <p/>
+     * <p>
      * If {@code nodes} contains exactly one element, then it is checked whether that one node is inside the multipolygon.
      */
Index: trunk/src/org/openstreetmap/josm/tools/I18n.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/I18n.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/I18n.java	(revision 6830)
@@ -32,9 +32,9 @@
  */
 public final class I18n {
-    
+
     private I18n() {
         // Hide default constructor for utils classes
     }
-    
+
     private enum PluralMode { MODE_NOTONE, MODE_NONE, MODE_GREATERONE,
         MODE_CS/*, MODE_AR*/, MODE_PL/*, MODE_RO*/, MODE_RU, MODE_SK/*, MODE_SL*/}
@@ -135,7 +135,7 @@
      * These strings are collected by a script that runs on the source code files.
      * After translation, the localizations are distributed with the main program.
-     * <br/>
+     * <br>
      * For example, {@code tr("JOSM''s default value is ''{0}''.", val)}.
-     * <br/>
+     * <br>
      * Use {@link #trn} for distinguishing singular from plural text, i.e.,
      * do not use {@code tr(size == 1 ? "singular" : "plural")} nor
@@ -207,5 +207,5 @@
      * Translates some text for the current locale and distinguishes between
      * {@code singularText} and {@code pluralText} depending on {@code n}.
-     * <br/>
+     * <br>
      * For instance, {@code trn("There was an error!", "There were errors!", i)} or
      * {@code trn("Found {0} error in {1}!", "Found {0} errors in {1}!", i, Integer.toString(i), url)}.
Index: trunk/src/org/openstreetmap/josm/tools/OsmUrlToBounds.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/OsmUrlToBounds.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/OsmUrlToBounds.java	(revision 6830)
@@ -85,5 +85,5 @@
      * Openstreetmap.org changed it's URL scheme in August 2013, which breaks the URL parsing.
      * The following function, called by the old parse function if necessary, provides parsing new URLs
-     * the new URLs follow the scheme http://www.openstreetmap.org/#map=18/51.71873/8.76164&layers=CN
+     * the new URLs follow the scheme http://www.openstreetmap.org/#map=18/51.71873/8.76164&amp;layers=CN
      * @param url string for parsing
      * @return Bounds if hashurl, {@code null} otherwise
@@ -294,5 +294,5 @@
      * @param zoom zoom depth of display
      * @return link to display that area in OSM map
-     * 
+     *
      * @since 6453
      */
Index: trunk/src/org/openstreetmap/josm/tools/PlatformHook.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/PlatformHook.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/PlatformHook.java	(revision 6830)
@@ -11,5 +11,5 @@
  */
 public interface PlatformHook {
-    
+
     /**
       * The preStartupHook will be called extremly early. It is
@@ -47,5 +47,5 @@
       * shortuts from this hook, but only "systemCuts"!
       *
-      * BTW: SystemCuts should be named "system:<whatever>",
+      * BTW: SystemCuts should be named "system:&lt;whatever&gt;",
       * and it'd be best if sou'd recycle the names already used
       * by the Windows and OSX hooks. Especially the later has
@@ -69,6 +69,6 @@
       * Another reason not to use the implementation in the *nix
       * hook are LAFs that don't understand HTML, such as the OSX LAFs.
-      * 
-     * @param name Tooltip text to display 
+      *
+     * @param name Tooltip text to display
      * @param sc Shortcut associated (to display accelerator between parenthesis)
      * @return Full tooltip text (name + accelerator)
Index: trunk/src/org/openstreetmap/josm/tools/TextTagParser.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/TextTagParser.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/TextTagParser.java	(revision 6830)
@@ -28,5 +28,5 @@
  */
 public final class TextTagParser {
-    
+
     // properties need JOSM restart to apply, modified rarely enough
     protected static final int MAX_KEY_LENGTH = Main.pref.getInteger("tags.paste.max-key-length", 50);
@@ -34,9 +34,9 @@
     protected static final String KEY_PATTERN = Main.pref.get("tags.paste.tag-pattern", "[0-9a-zA-Z:_]*");
     protected static final int MAX_VALUE_LENGTH = 255;
-    
+
     private TextTagParser() {
         // Hide default constructor for utils classes
     }
-    
+
     public static class TextAnalyzer {
         boolean quotesStarted = false;
@@ -52,5 +52,5 @@
             n = data.length();
         }
-        
+
         /**
          * Read tags from "Free format"
@@ -72,5 +72,5 @@
             return tags;
         }
-        
+
         private String parseString(String stopChars) {
             char[] stop = stopChars.toCharArray();
@@ -95,5 +95,5 @@
                     pos++;
                     break;
-                } else if (!quotesStarted && (Arrays.binarySearch(stop, c)>=0)) { 
+                } else if (!quotesStarted && (Arrays.binarySearch(stop, c)>=0)) {
                     // stop-symbol found
                     pos++;
@@ -110,5 +110,5 @@
             return res.trim();
         }
-        
+
         private void skipSign() {
             char c;
@@ -155,5 +155,5 @@
 
     /**
-     * Try to find tag-value pairs in given text  
+     * Try to find tag-value pairs in given text
      * @param text - text in which tags are looked for
      * @param splitRegex - text is splitted into parts with this delimiter
@@ -175,5 +175,5 @@
                      v = unescape(v);
                      if (k==null || v==null) return null;
-                 } 
+                 }
                  tags.put(k,v);
             } else {
@@ -185,12 +185,12 @@
          }  else {
             return null;
-         }    
-    }
- 
+         }
+    }
+
     public static Map<String,String> getValidatedTagsFromText(String buf) {
         Map<String,String> tags = readTagsFromText(buf);
         return validateTags(tags) ? tags : null;
     }
-    
+
     /**
      * Apply different methods to extract tag-value pairs from arbitrary text
@@ -198,8 +198,8 @@
      * @return null if no format is suitable
      */
-    
+
     public static Map<String,String> readTagsFromText(String buf) {
         Map<String,String> tags;
-        
+
         // Format
         // tag1\tval1\ntag2\tval2\n
@@ -209,5 +209,5 @@
 
         // Format
-        // a=b \n c=d \n "a b"=hello 
+        // a=b \n c=d \n "a b"=hello
         // SORRY: "a=b" = c is not supported fror now, only first = will be considered
         // a = "b=c" is OK
@@ -216,14 +216,14 @@
                 // try format  t1=v1\n t2=v2\n ...
         if (tags!=null) return tags;
-        
+
         // JSON-format
         String bufJson = buf.trim();
         // trim { }, if there are any
         if (bufJson.startsWith("{") && bufJson.endsWith("}") ) bufJson = bufJson.substring(1,bufJson.length()-1);
-        tags = readTagsByRegexp(bufJson, "[\\s]*,[\\s]*", 
+        tags = readTagsByRegexp(bufJson, "[\\s]*,[\\s]*",
                 "[\\s]*(\\\".*?[^\\\\]\\\")"+"[\\s]*:[\\s]*"+"(\\\".*?[^\\\\]\\\")[\\s]*", true);
         if (tags!=null) return tags;
 
-        // Free format 
+        // Free format
         // a 1 "b" 2 c=3 d 4 e "5"
         TextAnalyzer parser = new TextAnalyzer(buf);
@@ -234,5 +234,5 @@
     /**
      * Check tags for correctness and display warnings if needed
-     * @param tags - map key->value to check
+     * @param tags - map key-&gt;value to check
      * @return true if the tags should be pasted
      */
@@ -265,5 +265,5 @@
         return true;
     }
-    
+
     private static int warning(String text, String data, String code) {
         ExtendedDialog ed = new ExtendedDialog(
@@ -304,7 +304,7 @@
                     tr("Warning"),
                     new String[]{tr("Ok"), tr("Clear buffer")});
-        
+
         ed.setButtonIcons(new String[]{"ok.png", "dialogs/delete.png"});
-        
+
         ed.setContent(p);
         ed.setDefaultButton(1);
Index: trunk/src/org/openstreetmap/josm/tools/Utils.java
===================================================================
--- trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 6828)
+++ trunk/src/org/openstreetmap/josm/tools/Utils.java	(revision 6830)
@@ -261,5 +261,5 @@
 
     /**
-     * convert float range 0 <= x <= 1 to integer range 0..255
+     * convert float range 0 &lt;= x &lt;= 1 to integer range 0..255
      * when dealing with colors and color alpha value
      * @return null if val is null, the corresponding int if val is in the
@@ -275,5 +275,5 @@
 
     /**
-     * convert integer range 0..255 to float range 0 <= x <= 1
+     * convert integer range 0..255 to float range 0 &lt;= x &lt;= 1
      * when dealing with colors and color alpha value
      */
@@ -317,5 +317,5 @@
 
     /**
-     * Simple file copy function that will overwrite the target file.<br/>
+     * Simple file copy function that will overwrite the target file.<br>
      * Taken from <a href="http://www.rgagnon.com/javadetails/java-0064.html">this article</a> (CC-NC-BY-SA)
      * @param in The source file
@@ -526,5 +526,5 @@
      * Topological sort.
      *
-     * @param dependencies contains mappings (key -> value). In the final list of sorted objects, the key will come
+     * @param dependencies contains mappings (key -&gt; value). In the final list of sorted objects, the key will come
      * after the value. (In other words, the key depends on the value(s).)
      * There must not be cyclic dependencies.
@@ -836,5 +836,5 @@
      * @param elapsedTime The duration in milliseconds
      * @return A human readable string for the given duration
-     * @throws IllegalArgumentException if elapsedTime is < 0
+     * @throws IllegalArgumentException if elapsedTime is &lt; 0
      * @since 6354
      */
@@ -867,5 +867,5 @@
     /**
      * Returns a human readable representation of a list of positions.
-     * <p/>
+     * <p>
      * For instance, {@code [1,5,2,6,7} yields "1-2,5-7
      * @param positionList a list of positions